/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ILogFindProvider.java,v 1.7 2005/02/16 22:20:27 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.log.ui.internal.actions.provider;

import org.eclipse.hyades.log.ui.internal.util.LogFindCriteria;

public interface ILogFindProvider{

	/**
	 * Called when the Find dialog box OK button is pressed
	 * @param toApply user selection made in the dialog box
	 * @return not yet defined
	 */
	public boolean findRecord(LogFindCriteria criteria);
	public boolean storeFindOptions(LogFindCriteria criteria);
	public String loadFindPreferenceString();
	public boolean loadFindDirection();
}
