/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ContextPackage.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.context;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 *         Copyright (c) 2005 IBM Corporation and others.
 *         All rights reserved.   This program and the accompanying materials
 *         are made available under the terms of the Eclipse Public License v1.0
 *         which accompanies this distribution, and is available at
 *         http://www.eclipse.org/legal/epl-v10.html
 * 	  
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextFactory
 * @generated
 */
public interface ContextPackage extends EPackage{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "context";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/schema/Context.xsd";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "hga";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ContextPackage eINSTANCE = org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.impl.ComponentImpl <em>Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ComponentImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getComponent()
	 * @generated
	 */
	int COMPONENT = 0;

	/**
	 * The feature id for the '<em><b>Group</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__GROUP = 0;

	/**
	 * The feature id for the '<em><b>Component</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__COMPONENT = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Executable Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__EXECUTABLE_CLASS = 3;

	/**
	 * The feature id for the '<em><b>Implementation Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__IMPLEMENTATION_CREATION_DATE = 4;

	/**
	 * The feature id for the '<em><b>Implementation Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__IMPLEMENTATION_VERSION = 5;

	/**
	 * The feature id for the '<em><b>Implementation Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__IMPLEMENTATION_VERSION_DESCRIPTION = 6;

	/**
	 * The feature id for the '<em><b>Logging Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__LOGGING_LEVEL = 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__NAME = 8;

	/**
	 * The feature id for the '<em><b>Role</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__ROLE = 9;

	/**
	 * The feature id for the '<em><b>Role Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__ROLE_CREATION_DATE = 10;

	/**
	 * The feature id for the '<em><b>Role Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__ROLE_VERSION = 11;

	/**
	 * The feature id for the '<em><b>Role Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__ROLE_VERSION_DESCRIPTION = 12;

	/**
	 * The feature id for the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__UNIQUE_ID = 13;

	/**
	 * The number of structural features of the the '<em>Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_FEATURE_COUNT = 14;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextsTypeImpl <em>sType</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextsTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getContextsType()
	 * @generated
	 */
	int CONTEXT_STYPE = 1;

	/**
	 * The feature id for the '<em><b>Group</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_STYPE__GROUP = 0;

	/**
	 * The feature id for the '<em><b>Context</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_STYPE__CONTEXT = 1;

	/**
	 * The number of structural features of the the '<em>sType</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_STYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextTypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getContextType()
	 * @generated
	 */
	int CONTEXT_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Group</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__GROUP = 0;

	/**
	 * The feature id for the '<em><b>Component</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__COMPONENT = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Executable Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__EXECUTABLE_CLASS = 3;

	/**
	 * The feature id for the '<em><b>Implementation Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__IMPLEMENTATION_CREATION_DATE = 4;

	/**
	 * The feature id for the '<em><b>Implementation Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__IMPLEMENTATION_VERSION = 5;

	/**
	 * The feature id for the '<em><b>Implementation Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__IMPLEMENTATION_VERSION_DESCRIPTION = 6;

	/**
	 * The feature id for the '<em><b>Logging Level</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__LOGGING_LEVEL = 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__NAME = 8;

	/**
	 * The feature id for the '<em><b>Role</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__ROLE = 9;

	/**
	 * The feature id for the '<em><b>Role Creation Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__ROLE_CREATION_DATE = 10;

	/**
	 * The feature id for the '<em><b>Role Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__ROLE_VERSION = 11;

	/**
	 * The feature id for the '<em><b>Role Version Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__ROLE_VERSION_DESCRIPTION = 12;

	/**
	 * The feature id for the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE__UNIQUE_ID = 13;

	/**
	 * The number of structural features of the the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTEXT_TYPE_FEATURE_COUNT = 14;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.impl.DocumentRootImpl <em>Document Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.DocumentRootImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getDocumentRoot()
	 * @generated
	 */
	int DOCUMENT_ROOT = 3;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MIXED = 0;

	/**
	 * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

	/**
	 * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Context</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONTEXT = 3;

	/**
	 * The feature id for the '<em><b>Contexts</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__CONTEXTS = 4;

	/**
	 * The number of structural features of the the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames <em>Role Names</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getContextRoleNames()
	 * @generated
	 */
	int CONTEXT_ROLE_NAMES = 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames <em>Role Names</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getRoleNames()
	 * @generated
	 */
	int ROLE_NAMES = 5;

	/**
	 * The meta object id for the '<em>Role Names Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getContextRoleNamesObject()
	 * @generated
	 */
	int CONTEXT_ROLE_NAMES_OBJECT = 6;

	/**
	 * The meta object id for the '<em>Role Names Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl#getRoleNamesObject()
	 * @generated
	 */
	int ROLE_NAMES_OBJECT = 7;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component
	 * @generated
	 */
	EClass getComponent();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Group</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getGroup()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_Group();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Component</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getComponent()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_Component();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getDescription()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getExecutableClass <em>Executable Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Executable Class</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getExecutableClass()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_ExecutableClass();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationCreationDate <em>Implementation Creation Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Creation Date</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationCreationDate()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_ImplementationCreationDate();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersion <em>Implementation Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Version</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersion()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_ImplementationVersion();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersionDescription <em>Implementation Version Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Version Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getImplementationVersionDescription()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_ImplementationVersionDescription();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getLoggingLevel <em>Logging Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Logging Level</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getLoggingLevel()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_LoggingLevel();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getName()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole <em>Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRole()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_Role();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleCreationDate <em>Role Creation Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Creation Date</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleCreationDate()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_RoleCreationDate();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersion <em>Role Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Version</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersion()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_RoleVersion();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersionDescription <em>Role Version Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Version Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getRoleVersionDescription()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_RoleVersionDescription();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.Component#getUniqueID <em>Unique ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unique ID</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.Component#getUniqueID()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_UniqueID();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType <em>sType</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>sType</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType
	 * @generated
	 */
	EClass getContextsType();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Group</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType#getGroup()
	 * @see #getContextsType()
	 * @generated
	 */
	EAttribute getContextsType_Group();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Context</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextsType#getContext()
	 * @see #getContextsType()
	 * @generated
	 */
	EReference getContextsType_Context();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType
	 * @generated
	 */
	EClass getContextType();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getGroup <em>Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Group</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getGroup()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_Group();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Component</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getComponent()
	 * @see #getContextType()
	 * @generated
	 */
	EReference getContextType_Component();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getDescription()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getExecutableClass <em>Executable Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Executable Class</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getExecutableClass()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_ExecutableClass();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationCreationDate <em>Implementation Creation Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Creation Date</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationCreationDate()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_ImplementationCreationDate();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationVersion <em>Implementation Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Version</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationVersion()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_ImplementationVersion();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationVersionDescription <em>Implementation Version Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Implementation Version Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getImplementationVersionDescription()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_ImplementationVersionDescription();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getLoggingLevel <em>Logging Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Logging Level</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getLoggingLevel()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_LoggingLevel();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getName()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRole <em>Role</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRole()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_Role();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleCreationDate <em>Role Creation Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Creation Date</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleCreationDate()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_RoleCreationDate();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleVersion <em>Role Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Version</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleVersion()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_RoleVersion();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleVersionDescription <em>Role Version Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Role Version Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getRoleVersionDescription()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_RoleVersionDescription();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getUniqueID <em>Unique ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unique ID</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextType#getUniqueID()
	 * @see #getContextType()
	 * @generated
	 */
	EAttribute getContextType_UniqueID();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document Root</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot
	 * @generated
	 */
	EClass getDocumentRoot();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getMixed()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Mixed();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getXMLNSPrefixMap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XMLNSPrefixMap();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XSI Schema Location</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getXSISchemaLocation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XSISchemaLocation();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getContext <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Context</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getContext()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Context();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getContexts <em>Contexts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Contexts</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.DocumentRoot#getContexts()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Contexts();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames <em>Role Names</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Role Names</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames
	 * @generated
	 */
	EEnum getContextRoleNames();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames <em>Role Names</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Role Names</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @generated
	 */
	EEnum getRoleNames();

	/**
	 * Returns the meta object for data type '{@link org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames <em>Role Names Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Role Names Object</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames
	 * @model instanceClass="org.eclipse.hyades.logging.adapter.model.internal.context.ContextRoleNames"
	 * @generated
	 */
	EDataType getContextRoleNamesObject();

	/**
	 * Returns the meta object for data type '{@link org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames <em>Role Names Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Role Names Object</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames
	 * @model instanceClass="org.eclipse.hyades.logging.adapter.model.internal.context.RoleNames"
	 * @generated
	 */
	EDataType getRoleNamesObject();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ContextFactory getContextFactory();

} //ContextPackage
