/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: OutputterConfigType.java,v 1.10 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter;

import org.eclipse.hyades.logging.adapter.model.internal.unit.ProcessUnitType;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Config Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 *      An outputter takes an object and writes
 *                 it out to some destination.     Depending on the type of
 *                 outputter, the destination and parameters      are
 *                 specified in outputter property elements.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getSingleFileOutputterType <em>Single File Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getNotificationOutputterType <em>Notification Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType()
 * @model 
 * @generated
 */
public interface OutputterConfigType extends ProcessUnitType{
	/**
	 * Returns the value of the '<em><b>Single File Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Single File Outputter Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Single File Outputter Type</em>' containment reference.
	 * @see #setSingleFileOutputterType(SingleFileOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType_SingleFileOutputterType()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	SingleFileOutputterTypeType getSingleFileOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getSingleFileOutputterType <em>Single File Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Single File Outputter Type</em>' containment reference.
	 * @see #getSingleFileOutputterType()
	 * @generated
	 */
	void setSingleFileOutputterType(SingleFileOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Standard Out Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Standard Out Outputter Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Standard Out Outputter Type</em>' containment reference.
	 * @see #setStandardOutOutputterType(StandardOutOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType_StandardOutOutputterType()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	StandardOutOutputterTypeType getStandardOutOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Standard Out Outputter Type</em>' containment reference.
	 * @see #getStandardOutOutputterType()
	 * @generated
	 */
	void setStandardOutOutputterType(StandardOutOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Logging Agent Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Logging Agent Outputter Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Logging Agent Outputter Type</em>' containment reference.
	 * @see #setLoggingAgentOutputterType(LoggingAgentOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType_LoggingAgentOutputterType()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	LoggingAgentOutputterTypeType getLoggingAgentOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Logging Agent Outputter Type</em>' containment reference.
	 * @see #getLoggingAgentOutputterType()
	 * @generated
	 */
	void setLoggingAgentOutputterType(LoggingAgentOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Notification Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Notification Outputter Type</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Notification Outputter Type</em>' containment reference.
	 * @see #setNotificationOutputterType(NotificationOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType_NotificationOutputterType()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	NotificationOutputterTypeType getNotificationOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getNotificationOutputterType <em>Notification Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Notification Outputter Type</em>' containment reference.
	 * @see #getNotificationOutputterType()
	 * @generated
	 */
	void setNotificationOutputterType(NotificationOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"StandardOutOutputter"</code>.
	 * The literals are from the enumeration {@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @see #isSetType()
	 * @see #unsetType()
	 * @see #setType(OutputterType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getOutputterConfigType_Type()
	 * @model default="StandardOutOutputter" unique="false" unsettable="true" required="true"
	 * @generated
	 */
	OutputterType getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterType
	 * @see #isSetType()
	 * @see #unsetType()
	 * @see #getType()
	 * @generated
	 */
	void setType(OutputterType value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetType()
	 * @see #getType()
	 * @see #setType(OutputterType)
	 * @generated
	 */
	void unsetType();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterConfigType#getType <em>Type</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Type</em>' attribute is set.
	 * @see #unsetType()
	 * @see #getType()
	 * @see #setType(OutputterType)
	 * @generated
	 */
	boolean isSetType();

} // OutputterConfigType
