/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: SensorPackage.java,v 1.11 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.sensor;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.hyades.logging.adapter.model.internal.unit.UnitPackage;

import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 *           Copyright (c) 2005 IBM Corporation and others.
 *           All rights reserved.   This program and the accompanying materials
 *           are made available under the terms of the Eclipse Public License v1.0
 *           which accompanies this distribution, and is available at
 *           http://www.eclipse.org/legal/epl-v10.html
 *         
 * 
 *           Copyright (c) 2005 IBM Corporation and others.
 *           All rights reserved.   This program and the accompanying materials
 *           are made available under the terms of the Eclipse Public License v1.0
 *           which accompanies this distribution, and is available at
 *           http://www.eclipse.org/legal/epl-v10.html
 *         
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorFactory
 * @generated
 */
public interface SensorPackage extends EPackage{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "sensor";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/schema/Sensor.xsd";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "sensor";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SensorPackage eINSTANCE = org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorBaseTypeImpl <em>Base Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorBaseTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSensorBaseType()
	 * @generated
	 */
	int SENSOR_BASE_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Sensor Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_BASE_TYPE__SENSOR_PROPERTY = 0;

	/**
	 * The number of structural features of the the '<em>Base Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_BASE_TYPE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.AdapterCBESensorTypeImpl <em>Adapter CBE Sensor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.AdapterCBESensorTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getAdapterCBESensorType()
	 * @generated
	 */
	int ADAPTER_CBE_SENSOR_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Sensor Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTER_CBE_SENSOR_TYPE__SENSOR_PROPERTY = SENSOR_BASE_TYPE__SENSOR_PROPERTY;

	/**
	 * The number of structural features of the the '<em>Adapter CBE Sensor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTER_CBE_SENSOR_TYPE_FEATURE_COUNT = SENSOR_BASE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorConfigTypeImpl <em>Config Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorConfigTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSensorConfigType()
	 * @generated
	 */
	int SENSOR_CONFIG_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__PROPERTY = UnitPackage.PROCESS_UNIT_TYPE__PROPERTY;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__DESCRIPTION = UnitPackage.PROCESS_UNIT_TYPE__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__UNIQUE_ID = UnitPackage.PROCESS_UNIT_TYPE__UNIQUE_ID;

	/**
	 * The feature id for the '<em><b>Single File Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__SINGLE_FILE_SENSOR = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Adapter CBE Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__ADAPTER_CBE_SENSOR = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Static Parser Sensor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__STATIC_PARSER_SENSOR = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Confidence Buffer Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__CONFIDENCE_BUFFER_SIZE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>File Footer Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__FILE_FOOTER_SIZE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Maximum Blocking</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__MAXIMUM_BLOCKING = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE__TYPE = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the the '<em>Config Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_CONFIG_TYPE_FEATURE_COUNT = UnitPackage.PROCESS_UNIT_TYPE_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPropertyTypeImpl <em>Property Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPropertyTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSensorPropertyType()
	 * @generated
	 */
	int SENSOR_PROPERTY_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Property Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_PROPERTY_TYPE__PROPERTY_NAME = 0;

	/**
	 * The feature id for the '<em><b>Property Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_PROPERTY_TYPE__PROPERTY_VALUE = 1;

	/**
	 * The number of structural features of the the '<em>Property Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SENSOR_PROPERTY_TYPE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SingleFileSensorTypeImpl <em>Single File Sensor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SingleFileSensorTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSingleFileSensorType()
	 * @generated
	 */
	int SINGLE_FILE_SENSOR_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Sensor Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE__SENSOR_PROPERTY = SENSOR_BASE_TYPE__SENSOR_PROPERTY;

	/**
	 * The feature id for the '<em><b>Converter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE__CONVERTER = SENSOR_BASE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Directory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE__DIRECTORY = SENSOR_BASE_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>File Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE__FILE_NAME = SENSOR_BASE_TYPE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Shell</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE__SHELL = SENSOR_BASE_TYPE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the the '<em>Single File Sensor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_FILE_SENSOR_TYPE_FEATURE_COUNT = SENSOR_BASE_TYPE_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.StaticParserSensorTypeImpl <em>Static Parser Sensor Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.StaticParserSensorTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getStaticParserSensorType()
	 * @generated
	 */
	int STATIC_PARSER_SENSOR_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Sensor Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_PARSER_SENSOR_TYPE__SENSOR_PROPERTY = SENSOR_BASE_TYPE__SENSOR_PROPERTY;

	/**
	 * The feature id for the '<em><b>Directory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_PARSER_SENSOR_TYPE__DIRECTORY = SENSOR_BASE_TYPE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>File Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_PARSER_SENSOR_TYPE__FILE_NAME = SENSOR_BASE_TYPE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parser Class Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_PARSER_SENSOR_TYPE__PARSER_CLASS_NAME = SENSOR_BASE_TYPE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>Static Parser Sensor Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STATIC_PARSER_SENSOR_TYPE_FEATURE_COUNT = SENSOR_BASE_TYPE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType <em>Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSensorType()
	 * @generated
	 */
	int SENSOR_TYPE = 6;

	/**
	 * The meta object id for the '<em>Type Object</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl#getSensorTypeObject()
	 * @generated
	 */
	int SENSOR_TYPE_OBJECT = 7;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.AdapterCBESensorType <em>Adapter CBE Sensor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adapter CBE Sensor Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.AdapterCBESensorType
	 * @generated
	 */
	EClass getAdapterCBESensorType();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorBaseType <em>Base Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Base Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorBaseType
	 * @generated
	 */
	EClass getSensorBaseType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorBaseType#getSensorProperty <em>Sensor Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sensor Property</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorBaseType#getSensorProperty()
	 * @see #getSensorBaseType()
	 * @generated
	 */
	EReference getSensorBaseType_SensorProperty();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType <em>Config Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Config Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType
	 * @generated
	 */
	EClass getSensorConfigType();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getSingleFileSensor <em>Single File Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Single File Sensor</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getSingleFileSensor()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EReference getSensorConfigType_SingleFileSensor();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getAdapterCBESensor <em>Adapter CBE Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Adapter CBE Sensor</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getAdapterCBESensor()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EReference getSensorConfigType_AdapterCBESensor();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getStaticParserSensor <em>Static Parser Sensor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Static Parser Sensor</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getStaticParserSensor()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EReference getSensorConfigType_StaticParserSensor();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getConfidenceBufferSize <em>Confidence Buffer Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Confidence Buffer Size</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getConfidenceBufferSize()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EAttribute getSensorConfigType_ConfidenceBufferSize();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getFileFooterSize <em>File Footer Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>File Footer Size</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getFileFooterSize()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EAttribute getSensorConfigType_FileFooterSize();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getMaximumBlocking <em>Maximum Blocking</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Maximum Blocking</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getMaximumBlocking()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EAttribute getSensorConfigType_MaximumBlocking();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType#getType()
	 * @see #getSensorConfigType()
	 * @generated
	 */
	EAttribute getSensorConfigType_Type();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType <em>Property Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType
	 * @generated
	 */
	EClass getSensorPropertyType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType#getPropertyName <em>Property Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType#getPropertyName()
	 * @see #getSensorPropertyType()
	 * @generated
	 */
	EAttribute getSensorPropertyType_PropertyName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType#getPropertyValue <em>Property Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property Value</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPropertyType#getPropertyValue()
	 * @see #getSensorPropertyType()
	 * @generated
	 */
	EAttribute getSensorPropertyType_PropertyValue();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType <em>Single File Sensor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Single File Sensor Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType
	 * @generated
	 */
	EClass getSingleFileSensorType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getConverter <em>Converter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Converter</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getConverter()
	 * @see #getSingleFileSensorType()
	 * @generated
	 */
	EAttribute getSingleFileSensorType_Converter();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getDirectory <em>Directory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Directory</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getDirectory()
	 * @see #getSingleFileSensorType()
	 * @generated
	 */
	EAttribute getSingleFileSensorType_Directory();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getFileName <em>File Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>File Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getFileName()
	 * @see #getSingleFileSensorType()
	 * @generated
	 */
	EAttribute getSingleFileSensorType_FileName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getShell <em>Shell</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Shell</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getShell()
	 * @see #getSingleFileSensorType()
	 * @generated
	 */
	EAttribute getSingleFileSensorType_Shell();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType <em>Static Parser Sensor Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Static Parser Sensor Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType
	 * @generated
	 */
	EClass getStaticParserSensorType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getDirectory <em>Directory</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Directory</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getDirectory()
	 * @see #getStaticParserSensorType()
	 * @generated
	 */
	EAttribute getStaticParserSensorType_Directory();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getFileName <em>File Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>File Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getFileName()
	 * @see #getStaticParserSensorType()
	 * @generated
	 */
	EAttribute getStaticParserSensorType_FileName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getParserClassName <em>Parser Class Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parser Class Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.StaticParserSensorType#getParserClassName()
	 * @see #getStaticParserSensorType()
	 * @generated
	 */
	EAttribute getStaticParserSensorType_ParserClassName();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @generated
	 */
	EEnum getSensorType();

	/**
	 * Returns the meta object for data type '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType <em>Type Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Type Object</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType
	 * @model instanceClass="org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorType"
	 * @generated
	 */
	EDataType getSensorTypeObject();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SensorFactory getSensorFactory();

} //SensorPackage
