/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: SingleFileSensorType.java,v 1.10 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.sensor;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Single File Sensor Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 *      A single file sensor monitors a given
 *                 file in a given directory. If a converter is provided
 *                 it is used to preprocess the entire file as it existed
 *                 before reading it.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getConverter <em>Converter</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getDirectory <em>Directory</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getFileName <em>File Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getShell <em>Shell</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSingleFileSensorType()
 * @model 
 * @generated
 */
public interface SingleFileSensorType extends SensorBaseType {
	/**
	 * Returns the value of the '<em><b>Converter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Converter</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Converter</em>' attribute.
	 * @see #setConverter(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSingleFileSensorType_Converter()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getConverter();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getConverter <em>Converter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Converter</em>' attribute.
	 * @see #getConverter()
	 * @generated
	 */
	void setConverter(String value);

	/**
	 * Returns the value of the '<em><b>Directory</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *       The directory path of the input
	 *                     file that will be      read.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Directory</em>' attribute.
	 * @see #setDirectory(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSingleFileSensorType_Directory()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getDirectory();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getDirectory <em>Directory</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Directory</em>' attribute.
	 * @see #getDirectory()
	 * @generated
	 */
	void setDirectory(String value);

	/**
	 * Returns the value of the '<em><b>File Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *       The name of the input file that
	 *                     will be      read.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>File Name</em>' attribute.
	 * @see #setFileName(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSingleFileSensorType_FileName()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getFileName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getFileName <em>File Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>File Name</em>' attribute.
	 * @see #getFileName()
	 * @generated
	 */
	void setFileName(String value);

	/**
	 * Returns the value of the '<em><b>Shell</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Shell</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Shell</em>' attribute.
	 * @see #setShell(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSingleFileSensorType_Shell()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getShell();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SingleFileSensorType#getShell <em>Shell</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Shell</em>' attribute.
	 * @see #getShell()
	 * @generated
	 */
	void setShell(String value);

} // SingleFileSensorType
