/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: SensorConfigTypeItemProvider.java,v 1.11 2005/02/16 22:20:35 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.sensor.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;

import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType;
import org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage;

import org.eclipse.hyades.logging.adapter.model.internal.unit.provider.ProcessUnitTypeItemProvider;

import org.eclipse.hyades.logging.adapter.ui.AcadEditorPlugin;
import org.eclipse.hyades.logging.adapter.ui.AcadEditorPluginImages;

/**
 * This is the item provider adpater for a {@link org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorConfigType} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SensorConfigTypeItemProvider
	extends ProcessUnitTypeItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	public static final String MAX_BLOCKING = AcadEditorPlugin.getPlugin().getString("STR_SENSOR_MAXB");
	public static final String CONFIDENCE_BUFFER = AcadEditorPlugin.getPlugin().getString("STR_SENSOR_CONFB");
	public static final String FILE_FOOTER_BUFFER = AcadEditorPlugin.getPlugin().getString("STR_SENSOR_FOOTB");
	public static final String TYPE = AcadEditorPlugin.getPlugin().getString("_UI_SensorConfigType_type_feature");
	
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SensorConfigTypeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addConfidenceBufferSizePropertyDescriptor(object);
			addFileFooterSizePropertyDescriptor(object);
			addMaximumBlockingPropertyDescriptor(object);
			addTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Confidence Buffer Size feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addConfidenceBufferSizePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("_UI_SensorConfigType_confidenceBufferSize_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_SensorConfigType_confidenceBufferSize_feature", "_UI_SensorConfigType_type"),
				 SensorPackage.eINSTANCE.getSensorConfigType_ConfidenceBufferSize(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the File Footer Size feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addFileFooterSizePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("_UI_SensorConfigType_fileFooterSize_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_SensorConfigType_fileFooterSize_feature", "_UI_SensorConfigType_type"),
				 SensorPackage.eINSTANCE.getSensorConfigType_FileFooterSize(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Maximum Blocking feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addMaximumBlockingPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_SENSOR_MAXB"),
				 getString("_UI_PropertyDescriptor_description", "STR_SENSOR_MAXB", "_UI_SensorConfigType_type"),
				 SensorPackage.eINSTANCE.getSensorConfigType_MaximumBlocking(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}


	/**
	 * This adds a property descriptor for the Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("_UI_SensorConfigType_type_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_SensorConfigType_type_feature", "_UI_SensorConfigType_type"),
				 SensorPackage.eINSTANCE.getSensorConfigType_Type(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
//			childrenFeatures.add(SensorPackage.eINSTANCE.getSensorConfigType_SingleFileSensor());
//			childrenFeatures.add(SensorPackage.eINSTANCE.getSensorConfigType_AdapterCBESensor());
//			childrenFeatures.add(SensorPackage.eINSTANCE.getSensorConfigType_StaticParserSensor());
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}


	/**
	 * This specifies how to implement {@link #getChildren} 
	 * and {@link org.eclipse.emf.edit.command.AddCommand} and {@link org.eclipse.emf.edit.command.RemoveCommand} 
	 * support in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Collection getChildrenReferences(Object object) {
		if (childrenReferences == null) {
			super.getChildrenReferences(object);
//			childrenReferences.add(SensorPackage.eINSTANCE.getSensorConfigType_SingleFileSensor());
//			childrenReferences.add(SensorPackage.eINSTANCE.getSensorConfigType_AdapterCBESensor());
//			childrenReferences.add(SensorPackage.eINSTANCE.getSensorConfigType_StaticParserSensor());
		}
		return childrenReferences;
	}

	/**
	 * This returns SensorConfigType.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getImage(Object object) {
		return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_SENSOR);
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((SensorConfigType)object).getDescription();
		return label == null || label.length() == 0 ?
			getString("_UI_SensorConfigType_type") :
			getString("_UI_SensorConfigType_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(SensorConfigType.class)) {
			case SensorPackage.SENSOR_CONFIG_TYPE__CONFIDENCE_BUFFER_SIZE:
			case SensorPackage.SENSOR_CONFIG_TYPE__FILE_FOOTER_SIZE:
			case SensorPackage.SENSOR_CONFIG_TYPE__MAXIMUM_BLOCKING:
			case SensorPackage.SENSOR_CONFIG_TYPE__TYPE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case SensorPackage.SENSOR_CONFIG_TYPE__SINGLE_FILE_SENSOR:
			case SensorPackage.SENSOR_CONFIG_TYPE__ADAPTER_CBE_SENSOR:
			case SensorPackage.SENSOR_CONFIG_TYPE__STATIC_PARSER_SENSOR:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

//		newChildDescriptors.add
//			(createChildParameter
//				(SensorPackage.eINSTANCE.getSensorConfigType_SingleFileSensor(),
//				 SensorFactory.eINSTANCE.createSingleFileSensorType()));
//
//		newChildDescriptors.add
//			(createChildParameter
//				(SensorPackage.eINSTANCE.getSensorConfigType_AdapterCBESensor(),
//				 SensorFactory.eINSTANCE.createAdapterCBESensorType()));
//
//		newChildDescriptors.add
//			(createChildParameter
//				(SensorPackage.eINSTANCE.getSensorConfigType_StaticParserSensor(),
//				 SensorFactory.eINSTANCE.createStaticParserSensorType()));
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return AcadEditorPlugin.INSTANCE;
	}
}
