/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CBEComponentIdentification.java,v 1.10 2005/05/09 05:05:15 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.cbe;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Identification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A component is a modular unit of a running system that has been defined to be a source of events, or a reporter of events. Typically these are large grained parts of a system, or services that are provided to a system. However the notion of a component is up to the system itslef to define.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocation <em>Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocationType <em>Location Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getApplication <em>Application</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getExecutionEnvironment <em>Execution Environment</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponent <em>Component</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getSubComponent <em>Sub Component</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentIdType <em>Component Id Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getInstanceId <em>Instance Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getProcessId <em>Process Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getThreadId <em>Thread Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentType <em>Component Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification()
 * @model 
 * @generated
 */
public interface CBEComponentIdentification extends EObject{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Location</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' attribute.
	 * @see #setLocation(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_Location()
	 * @model 
	 * @generated
	 */
	String getLocation();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocation <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location</em>' attribute.
	 * @see #getLocation()
	 * @generated
	 */
	void setLocation(String value);

	/**
	 * Returns the value of the '<em><b>Location Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Location Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location Type</em>' attribute.
	 * @see #setLocationType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_LocationType()
	 * @model 
	 * @generated
	 */
	String getLocationType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocationType <em>Location Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location Type</em>' attribute.
	 * @see #getLocationType()
	 * @generated
	 */
	void setLocationType(String value);

	/**
	 * Returns the value of the '<em><b>Application</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Application</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Application</em>' attribute.
	 * @see #setApplication(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_Application()
	 * @model 
	 * @generated
	 */
	String getApplication();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getApplication <em>Application</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Application</em>' attribute.
	 * @see #getApplication()
	 * @generated
	 */
	void setApplication(String value);

	/**
	 * Returns the value of the '<em><b>Execution Environment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Execution Environment</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Execution Environment</em>' attribute.
	 * @see #setExecutionEnvironment(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_ExecutionEnvironment()
	 * @model 
	 * @generated
	 */
	String getExecutionEnvironment();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getExecutionEnvironment <em>Execution Environment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Execution Environment</em>' attribute.
	 * @see #getExecutionEnvironment()
	 * @generated
	 */
	void setExecutionEnvironment(String value);

	/**
	 * Returns the value of the '<em><b>Component</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component</em>' attribute.
	 * @see #setComponent(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_Component()
	 * @model 
	 * @generated
	 */
	String getComponent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponent <em>Component</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Component</em>' attribute.
	 * @see #getComponent()
	 * @generated
	 */
	void setComponent(String value);

	/**
	 * Returns the value of the '<em><b>Sub Component</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sub Component</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sub Component</em>' attribute.
	 * @see #setSubComponent(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_SubComponent()
	 * @model 
	 * @generated
	 */
	String getSubComponent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getSubComponent <em>Sub Component</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sub Component</em>' attribute.
	 * @see #getSubComponent()
	 * @generated
	 */
	void setSubComponent(String value);

	/**
	 * Returns the value of the '<em><b>Component Id Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component Id Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component Id Type</em>' attribute.
	 * @see #setComponentIdType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_ComponentIdType()
	 * @model 
	 * @generated
	 */
	String getComponentIdType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentIdType <em>Component Id Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Component Id Type</em>' attribute.
	 * @see #getComponentIdType()
	 * @generated
	 */
	void setComponentIdType(String value);

	/**
	 * Returns the value of the '<em><b>Instance Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance Id</em>' attribute.
	 * @see #setInstanceId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_InstanceId()
	 * @model 
	 * @generated
	 */
	String getInstanceId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getInstanceId <em>Instance Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Instance Id</em>' attribute.
	 * @see #getInstanceId()
	 * @generated
	 */
	void setInstanceId(String value);

	/**
	 * Returns the value of the '<em><b>Process Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This property identifies the processID of the "running" component or subcomponent that generated the artifact.  This property is optional.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Process Id</em>' attribute.
	 * @see #setProcessId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_ProcessId()
	 * @model 
	 * @generated
	 */
	String getProcessId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getProcessId <em>Process Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process Id</em>' attribute.
	 * @see #getProcessId()
	 * @generated
	 */
	void setProcessId(String value);

	/**
	 * Returns the value of the '<em><b>Thread Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Thread Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * This property identifies the ThreadID of the component or subcomponent indicated by the Process ID that generated the artifact.  A running process may spawn one or more thread to carry its function and/or incoming requests, the ThreadID will change accordingly. This property is optional.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Thread Id</em>' attribute.
	 * @see #setThreadId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_ThreadId()
	 * @model 
	 * @generated
	 */
	String getThreadId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getThreadId <em>Thread Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Thread Id</em>' attribute.
	 * @see #getThreadId()
	 * @generated
	 */
	void setThreadId(String value);

	/**
	 * Returns the value of the '<em><b>Component Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component Type</em>' attribute.
	 * @see #setComponentType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEComponentIdentification_ComponentType()
	 * @model 
	 * @generated
	 */
	String getComponentType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentType <em>Component Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Component Type</em>' attribute.
	 * @see #getComponentType()
	 * @generated
	 */
	void setComponentType(String value);

} // CBEComponentIdentification
