/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CMNAnnotation.java,v 1.6 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.common;

import org.eclipse.hyades.models.common.facades.behavioral.IAnnotation;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CMN Annotation</b></em>'.
 * @extends IAnnotation
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A CMNAnnotation represents a model annotation which is stored as a named file attachment in the same EMF resource as the model element that has been annotated.  Each annotation has a name and a URI.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.common.CMNAnnotation#getURI <em>URI</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.common.CMNAnnotation#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.common.CommonPackage#getCMNAnnotation()
 * @model 
 * @generated
 */
public interface CMNAnnotation extends CMNNamedElement, IAnnotation{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>URI</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>URI</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>URI</em>' attribute.
	 * @see #setURI(String)
	 * @see org.eclipse.hyades.models.common.common.CommonPackage#getCMNAnnotation_URI()
	 * @model 
	 * @generated
	 */
	String getURI();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.common.CMNAnnotation#getURI <em>URI</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>URI</em>' attribute.
	 * @see #getURI()
	 * @generated
	 */
	void setURI(String value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see org.eclipse.hyades.models.common.common.CommonPackage#getCMNAnnotation_Type()
	 * @model 
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.common.CMNAnnotation#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

} // CMNAnnotation
