/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: CommonPackageImpl.java,v 1.12 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.common.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.impl.EcorePackageImpl;

import org.eclipse.hyades.models.common.common.CMNAnnotation;
import org.eclipse.hyades.models.common.common.CMNDefaultProperty;
import org.eclipse.hyades.models.common.common.CMNExtendedProperty;
import org.eclipse.hyades.models.common.common.CMNMachine;
import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.common.CMNNodeInstance;
import org.eclipse.hyades.models.common.common.CMNNodeType;
import org.eclipse.hyades.models.common.common.CommonFactory;
import org.eclipse.hyades.models.common.common.CommonPackage;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.configuration.impl.Common_ConfigurationPackageImpl;
import org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage;
import org.eclipse.hyades.models.common.datapool.impl.Common_DatapoolPackageImpl;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;
import org.eclipse.hyades.models.common.fragments.impl.Common_Behavior_FragmentsPackageImpl;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;
import org.eclipse.hyades.models.common.interactions.impl.Common_Behavior_InteractionsPackageImpl;
import org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage;
import org.eclipse.hyades.models.common.testprofile.impl.Common_TestprofilePackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CommonPackageImpl extends EPackageImpl implements CommonPackage
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnNamedElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnMachineEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnNodeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnNodeInstanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnExtendedPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnDefaultPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass cmnAnnotationEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.models.common.common.CommonPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private CommonPackageImpl() {
		super(eNS_URI, CommonFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static CommonPackage init() {
		if (isInited) return (CommonPackage)EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI);

		// Obtain or create and register package
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof CommonPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new CommonPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		EcorePackageImpl.init();

		// Obtain or create and register interdependencies
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_InteractionsPackage.eNS_URI) instanceof Common_Behavior_InteractionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_InteractionsPackage.eNS_URI) : Common_Behavior_InteractionsPackageImpl.eINSTANCE);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI) instanceof Common_Behavior_FragmentsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI) : Common_Behavior_FragmentsPackageImpl.eINSTANCE);
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI) instanceof Common_TestprofilePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI) : Common_TestprofilePackageImpl.eINSTANCE);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI) instanceof Common_ConfigurationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI) : Common_ConfigurationPackageImpl.eINSTANCE);
		Common_DatapoolPackageImpl theCommon_DatapoolPackage = (Common_DatapoolPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(Common_DatapoolPackage.eNS_URI) instanceof Common_DatapoolPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(Common_DatapoolPackage.eNS_URI) : Common_DatapoolPackageImpl.eINSTANCE);

		// Create package meta-data objects
		theCommonPackage.createPackageContents();
		theCommon_Behavior_InteractionsPackage.createPackageContents();
		theCommon_Behavior_FragmentsPackage.createPackageContents();
		theCommon_TestprofilePackage.createPackageContents();
		theCommon_ConfigurationPackage.createPackageContents();
		theCommon_DatapoolPackage.createPackageContents();

		// Initialize created meta-data
		theCommonPackage.initializePackageContents();
		theCommon_Behavior_InteractionsPackage.initializePackageContents();
		theCommon_Behavior_FragmentsPackage.initializePackageContents();
		theCommon_TestprofilePackage.initializePackageContents();
		theCommon_ConfigurationPackage.initializePackageContents();
		theCommon_DatapoolPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theCommonPackage.freeze();

		return theCommonPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNNamedElement() {
		return cmnNamedElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNNamedElement_Id() {
		return (EAttribute)cmnNamedElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNNamedElement_Name() {
		return (EAttribute)cmnNamedElementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNMachine() {
		return cmnMachineEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNNodeType() {
		return cmnNodeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNNodeType_Hostname() {
		return (EAttribute)cmnNodeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNNodeInstance() {
		return cmnNodeInstanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNNodeInstance_Hostname() {
		return (EAttribute)cmnNodeInstanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNExtendedProperty() {
		return cmnExtendedPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNExtendedProperty_Name() {
		return (EAttribute)cmnExtendedPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNExtendedProperty_Type() {
		return (EAttribute)cmnExtendedPropertyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNExtendedProperty_Value() {
		return (EAttribute)cmnExtendedPropertyEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNDefaultProperty() {
		return cmnDefaultPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCMNAnnotation() {
		return cmnAnnotationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNAnnotation_URI() {
		return (EAttribute)cmnAnnotationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNAnnotation_Type() {
		return (EAttribute)cmnAnnotationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCMNNamedElement_Description() {
		return (EAttribute)cmnNamedElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CommonFactory getCommonFactory() {
		return (CommonFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		cmnNamedElementEClass = createEClass(CMN_NAMED_ELEMENT);
		createEAttribute(cmnNamedElementEClass, CMN_NAMED_ELEMENT__ID);
		createEAttribute(cmnNamedElementEClass, CMN_NAMED_ELEMENT__DESCRIPTION);
		createEAttribute(cmnNamedElementEClass, CMN_NAMED_ELEMENT__NAME);

		cmnMachineEClass = createEClass(CMN_MACHINE);

		cmnNodeTypeEClass = createEClass(CMN_NODE_TYPE);
		createEAttribute(cmnNodeTypeEClass, CMN_NODE_TYPE__HOSTNAME);

		cmnNodeInstanceEClass = createEClass(CMN_NODE_INSTANCE);
		createEAttribute(cmnNodeInstanceEClass, CMN_NODE_INSTANCE__HOSTNAME);

		cmnExtendedPropertyEClass = createEClass(CMN_EXTENDED_PROPERTY);
		createEAttribute(cmnExtendedPropertyEClass, CMN_EXTENDED_PROPERTY__NAME);
		createEAttribute(cmnExtendedPropertyEClass, CMN_EXTENDED_PROPERTY__TYPE);
		createEAttribute(cmnExtendedPropertyEClass, CMN_EXTENDED_PROPERTY__VALUE);

		cmnDefaultPropertyEClass = createEClass(CMN_DEFAULT_PROPERTY);

		cmnAnnotationEClass = createEClass(CMN_ANNOTATION);
		createEAttribute(cmnAnnotationEClass, CMN_ANNOTATION__URI);
		createEAttribute(cmnAnnotationEClass, CMN_ANNOTATION__TYPE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		Common_Behavior_InteractionsPackageImpl theCommon_Behavior_InteractionsPackage = (Common_Behavior_InteractionsPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_InteractionsPackage.eNS_URI);
		Common_Behavior_FragmentsPackageImpl theCommon_Behavior_FragmentsPackage = (Common_Behavior_FragmentsPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_Behavior_FragmentsPackage.eNS_URI);
		Common_TestprofilePackageImpl theCommon_TestprofilePackage = (Common_TestprofilePackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_TestprofilePackage.eNS_URI);
		Common_ConfigurationPackageImpl theCommon_ConfigurationPackage = (Common_ConfigurationPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_ConfigurationPackage.eNS_URI);
		Common_DatapoolPackageImpl theCommon_DatapoolPackage = (Common_DatapoolPackageImpl)EPackage.Registry.INSTANCE.getEPackage(Common_DatapoolPackage.eNS_URI);

		// Add subpackages
		getESubpackages().add(theCommon_Behavior_InteractionsPackage);
		getESubpackages().add(theCommon_Behavior_FragmentsPackage);
		getESubpackages().add(theCommon_TestprofilePackage);
		getESubpackages().add(theCommon_ConfigurationPackage);
		getESubpackages().add(theCommon_DatapoolPackage);

		// Add supertypes to classes
		cmnMachineEClass.getESuperTypes().add(this.getCMNNodeType());
		cmnNodeTypeEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGLocation());
		cmnNodeInstanceEClass.getESuperTypes().add(theCommon_ConfigurationPackage.getCFGLocation());
		cmnExtendedPropertyEClass.getESuperTypes().add(this.getCMNDefaultProperty());
		cmnAnnotationEClass.getESuperTypes().add(this.getCMNNamedElement());

		// Initialize classes and features; add operations and parameters
		initEClass(cmnNamedElementEClass, CMNNamedElement.class, "CMNNamedElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCMNNamedElement_Id(), ecorePackage.getEString(), "id", null, 0, 1, CMNNamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCMNNamedElement_Description(), ecorePackage.getEString(), "description", null, 0, 1, CMNNamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCMNNamedElement_Name(), ecorePackage.getEString(), "name", null, 0, 1, CMNNamedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cmnMachineEClass, CMNMachine.class, "CMNMachine", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cmnNodeTypeEClass, CMNNodeType.class, "CMNNodeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCMNNodeType_Hostname(), ecorePackage.getEString(), "hostname", null, 0, 1, CMNNodeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cmnNodeInstanceEClass, CMNNodeInstance.class, "CMNNodeInstance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCMNNodeInstance_Hostname(), ecorePackage.getEString(), "hostname", null, 0, 1, CMNNodeInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cmnExtendedPropertyEClass, CMNExtendedProperty.class, "CMNExtendedProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCMNExtendedProperty_Name(), ecorePackage.getEString(), "name", null, 0, 1, CMNExtendedProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCMNExtendedProperty_Type(), ecorePackage.getEString(), "type", null, 0, 1, CMNExtendedProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCMNExtendedProperty_Value(), ecorePackage.getEString(), "value", null, 0, 1, CMNExtendedProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(cmnDefaultPropertyEClass, CMNDefaultProperty.class, "CMNDefaultProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(cmnAnnotationEClass, CMNAnnotation.class, "CMNAnnotation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCMNAnnotation_URI(), ecorePackage.getEString(), "URI", null, 0, 1, CMNAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCMNAnnotation_Type(), ecorePackage.getEString(), "type", null, 0, 1, CMNAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //CommonPackageImpl
