/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DPLRole.java,v 1.9 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.datapool;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>DPL Role</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLRole()
 * @model
 * @generated
 */
public final class DPLRole extends AbstractEnumerator {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The '<em><b>Unspecified Data</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNSPECIFIED_DATA_LITERAL
	 * @model name="UnspecifiedData"
	 * @generated
	 * @ordered
	 */
	public static final int UNSPECIFIED_DATA = 0;

	/**
	 * The '<em><b>Input Data</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INPUT_DATA_LITERAL
	 * @model name="InputData"
	 * @generated
	 * @ordered
	 */
	public static final int INPUT_DATA = 1;

	/**
	 * The '<em><b>Output Data</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #OUTPUT_DATA_LITERAL
	 * @model name="OutputData"
	 * @generated
	 * @ordered
	 */
	public static final int OUTPUT_DATA = 2;

	/**
	 * The '<em><b>Input Output Data</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INPUT_OUTPUT_DATA_LITERAL
	 * @model name="InputOutputData"
	 * @generated
	 * @ordered
	 */
	public static final int INPUT_OUTPUT_DATA = 3;

	/**
	 * The '<em><b>Unspecified Data</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Unspecified Data</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNSPECIFIED_DATA
	 * @generated
	 * @ordered
	 */
	public static final DPLRole UNSPECIFIED_DATA_LITERAL = new DPLRole(UNSPECIFIED_DATA, "UnspecifiedData");

	/**
	 * The '<em><b>Input Data</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Input Data</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INPUT_DATA
	 * @generated
	 * @ordered
	 */
	public static final DPLRole INPUT_DATA_LITERAL = new DPLRole(INPUT_DATA, "InputData");

	/**
	 * The '<em><b>Output Data</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Output Data</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #OUTPUT_DATA
	 * @generated
	 * @ordered
	 */
	public static final DPLRole OUTPUT_DATA_LITERAL = new DPLRole(OUTPUT_DATA, "OutputData");

	/**
	 * The '<em><b>Input Output Data</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Input Output Data</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INPUT_OUTPUT_DATA
	 * @generated
	 * @ordered
	 */
	public static final DPLRole INPUT_OUTPUT_DATA_LITERAL = new DPLRole(INPUT_OUTPUT_DATA, "InputOutputData");

	/**
	 * An array of all the '<em><b>DPL Role</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final DPLRole[] VALUES_ARRAY =
		new DPLRole[] {
			UNSPECIFIED_DATA_LITERAL,
			INPUT_DATA_LITERAL,
			OUTPUT_DATA_LITERAL,
			INPUT_OUTPUT_DATA_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>DPL Role</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>DPL Role</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DPLRole get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			DPLRole result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>DPL Role</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DPLRole get(int value) {
		switch (value) {
			case UNSPECIFIED_DATA: return UNSPECIFIED_DATA_LITERAL;
			case INPUT_DATA: return INPUT_DATA_LITERAL;
			case OUTPUT_DATA: return OUTPUT_DATA_LITERAL;
			case INPUT_OUTPUT_DATA: return INPUT_OUTPUT_DATA_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private DPLRole(int value, String name) {
		super(value, name);
	}

} //DPLRole
