/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TPFTestSuite.java,v 1.11 2005/03/28 21:51:31 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.models.common.configuration.CFGClass;
import org.eclipse.hyades.models.common.facades.behavioral.ITestSuite;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TPF Test Suite</b></em>'.
 * @extends ITestSuite
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A Test Suite acts as a grouping mechanism for a set of test cases. 
 * 
 * It can be related to a TestObjective, defining the motivation of the TestSuite.
 * 
 * The behavior of a test suite is generally used for control the execution flow between its test cases or to invokes external test suites or test cases.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getPersistenceId <em>Persistence Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getTestCases <em>Test Cases</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getSUTs <em>SU Ts</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getArbiter <em>Arbiter</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getTestComponents <em>Test Components</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getReferencedSuites <em>Referenced Suites</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getDatapools <em>Datapools</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite()
 * @model 
 * @generated
 */
public interface TPFTestSuite extends CFGClass, TPFTest, ITestSuite{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Persistence Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Persistence Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Persistence Id</em>' attribute.
	 * @see #setPersistenceId(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_PersistenceId()
	 * @model 
	 * @generated
	 */
	String getPersistenceId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getPersistenceId <em>Persistence Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Persistence Id</em>' attribute.
	 * @see #getPersistenceId()
	 * @generated
	 */
	void setPersistenceId(String value);

	/**
	 * Returns the value of the '<em><b>Test Cases</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFTestCase}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFTestCase#getTestSuite <em>Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Test Cases</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Test Cases</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_TestCases()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestCase#getTestSuite
	 * @model type="org.eclipse.hyades.models.common.testprofile.TPFTestCase" opposite="testSuite" containment="true"
	 * @generated
	 */
	EList getTestCases();

	/**
	 * Returns the value of the '<em><b>SU Ts</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFSUT}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getTestSuite <em>Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>SU Ts</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>SU Ts</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_SUTs()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFSUT#getTestSuite
	 * @model type="org.eclipse.hyades.models.common.testprofile.TPFSUT" opposite="testSuite" containment="true"
	 * @generated
	 */
	EList getSUTs();

	/**
	 * Returns the value of the '<em><b>Arbiter</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFArbiter#getTestSuite <em>Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Arbiter</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Arbiter</em>' containment reference.
	 * @see #setArbiter(TPFArbiter)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_Arbiter()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFArbiter#getTestSuite
	 * @model opposite="testSuite" containment="true"
	 * @generated
	 */
	TPFArbiter getArbiter();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getArbiter <em>Arbiter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Arbiter</em>' containment reference.
	 * @see #getArbiter()
	 * @generated
	 */
	void setArbiter(TPFArbiter value);

	/**
	 * Returns the value of the '<em><b>Test Components</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFTestComponent}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFTestComponent#getTestSuite <em>Test Suite</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Test Components</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Test Components</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_TestComponents()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestComponent#getTestSuite
	 * @model type="org.eclipse.hyades.models.common.testprofile.TPFTestComponent" opposite="testSuite" containment="true"
	 * @generated
	 */
	EList getTestComponents();

	/**
	 * Returns the value of the '<em><b>Referenced Suites</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Referenced Suites</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Referenced Suites</em>' reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_ReferencedSuites()
	 * @model type="org.eclipse.hyades.models.common.testprofile.TPFTestSuite"
	 * @generated
	 */
	EList getReferencedSuites();

	/**
	 * Returns the value of the '<em><b>Datapools</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.datapool.DPLDatapool}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Datapools</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Datapools</em>' reference list.
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFTestSuite_Datapools()
	 * @model type="org.eclipse.hyades.models.common.datapool.DPLDatapool"
	 * @generated
	 */
	EList getDatapools();

} // TPFTestSuite
