/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: UnresolvedCorrelation.java,v 1.16 2005/03/16 19:07:50 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Unresolved Correlation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Class used to persist the unresolved correlations. When a correlation is  resolved the object should be removed form the list.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.UnresolvedCorrelation#getContextId <em>Context Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.UnresolvedCorrelation#getAgent <em>Agent</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.UnresolvedCorrelation#getSourceInfos <em>Source Infos</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getUnresolvedCorrelation()
 * @model 
 * @generated
 */
public interface UnresolvedCorrelation extends EObject{
	/**
	 * Returns the value of the '<em><b>Context Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * String based look-up key (eg. in Trace submodel case this is a concatenation of runtimeIds, ticket, sequence and threadId). The schema of this ID can be arbitrary chosen and has to be know by both the producer the consumer of this class.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Context Id</em>' attribute.
	 * @see #setContextId(String)
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getUnresolvedCorrelation_ContextId()
	 * @model 
	 * @generated
	 */
	String getContextId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.UnresolvedCorrelation#getContextId <em>Context Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Context Id</em>' attribute.
	 * @see #getContextId()
	 * @generated
	 */
	void setContextId(String value);

	/**
	 * Returns the value of the '<em><b>Agent</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.hierarchy.TRCAgent#getUnresolvedCorrelations <em>Unresolved Correlations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Agent</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Agent</em>' container reference.
	 * @see #setAgent(TRCAgent)
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getUnresolvedCorrelation_Agent()
	 * @see org.eclipse.hyades.models.hierarchy.TRCAgent#getUnresolvedCorrelations
	 * @model opposite="unresolvedCorrelations" required="true"
	 * @generated
	 */
	TRCAgent getAgent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.UnresolvedCorrelation#getAgent <em>Agent</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Agent</em>' container reference.
	 * @see #getAgent()
	 * @generated
	 */
	void setAgent(TRCAgent value);

	/**
	 * Returns the value of the '<em><b>Source Infos</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.hierarchy.CorrelationSourceInfo}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.hierarchy.CorrelationSourceInfo#getTargetInfo <em>Target Info</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Infos</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source Infos</em>' containment reference list.
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getUnresolvedCorrelation_SourceInfos()
	 * @see org.eclipse.hyades.models.hierarchy.CorrelationSourceInfo#getTargetInfo
	 * @model type="org.eclipse.hyades.models.hierarchy.CorrelationSourceInfo" opposite="targetInfo" containment="true"
	 * @generated
	 */
	EList getSourceInfos();

} // UnresolvedCorrelation
