/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCLinePerformanceData.java,v 1.6 2005/02/10 22:13:41 qiyanli Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.trace;


import org.eclipse.hyades.models.trace.util.LLUnitData;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Line Performance Data</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Aims to actually contain accumulated time data.
 * WARNING: Should not be used directly, but rather querying TRCLLData.getUnitData().
 * To be interpreted thanks to LLUnitData that will contain as a result of the query everything useful without wondering which kind of line level data has been collected.
 * Count information belongs to the class extended (see TRCLineCoverageData.countTable).
 * An accumulativeTimeTable item contains the sum of the time (in seconds) of the successive runs of the corresponding line level unit.
 * This system does not handle min and max values.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.trace.TRCLinePerformanceData#getAccumulatedTimeTable <em>Accumulated Time Table</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCLinePerformanceData()
 * @model 
 * @generated
 */
public interface TRCLinePerformanceData extends TRCLineCoverageData{
	/**
	 * Returns the value of the '<em><b>Accumulated Time Table</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Accumulated Time Table</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Accumulated Time Table</em>' attribute.
	 * @see #setAccumulatedTimeTable(double[])
	 * @see org.eclipse.hyades.models.trace.TracePackage#getTRCLinePerformanceData_AccumulatedTimeTable()
	 * @model dataType="org.eclipse.hyades.models.hierarchy.DoubleArray"
	 * @generated
	 */
	double[] getAccumulatedTimeTable();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.trace.TRCLinePerformanceData#getAccumulatedTimeTable <em>Accumulated Time Table</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Accumulated Time Table</em>' attribute.
	 * @see #getAccumulatedTimeTable()
	 * @generated
	 */
	void setAccumulatedTimeTable(double[] value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns an LLUnitData object with detailed information about the indicated unit_number. If instance is not null, then that instance is re-used (overwriting its fields with new data) and returned. Reusing the object instance saves construction time and heap traffic. See below for restrictions on re-using an LLUnitData instance. Unit numbers range from zero to getUnitCount()-1.
	 * 
	 * <!-- end-model-doc -->
	 * @model dataType="org.eclipse.hyades.models.trace.LLUnitData" parameters="org.eclipse.emf.ecore.EInt org.eclipse.hyades.models.trace.LLUnitData"
	 * @generated
	 */
	LLUnitData getUnitData(int unitNumber, LLUnitData instance);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns true if count information is filled in, i.e. countTable is not null
	 * <!-- end-model-doc -->
	 * @model 
	 * @generated
	 */
	boolean hasCountInfo();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns false
	 * <!-- end-model-doc -->
	 * @model 
	 * @generated
	 */
	boolean hasAccumulatedTimeInfo();

} // TRCLinePerformanceData
