/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Constraint.java,v 1.4 2005/02/16 22:21:28 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.resources.database.internal.dbmodel;

import org.eclipse.emf.common.util.EList;
/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Constraint</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.resources.database.internal.dbmodel.Constraint#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.resources.database.internal.dbmodel.Constraint#getColumns <em>Columns</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.resources.database.internal.dbmodel.DbmodelPackage#getConstraint()
 * @model
 * @generated
 */
public interface Constraint extends DBElement {
	/**

	 * Returns the value of the '<em><b>Type</b></em>' attribute.

	 * <!-- begin-user-doc -->

	 * <p>

	 * If the meaning of the '<em>Type</em>' attribute isn't clear,

	 * there really should be more of a description here...

	 * </p>

	 * <!-- end-user-doc -->

	 * @return the value of the '<em>Type</em>' attribute.

	 * @see #setType(String)

	 * @see org.eclipse.hyades.resources.database.internal.dbmodel.DbmodelPackage#getConstraint_Type()

	 * @model 

	 * @generated

	 */

	String getType();

	/**

	 * Sets the value of the '{@link org.eclipse.hyades.resources.database.internal.dbmodel.Constraint#getType <em>Type</em>}' attribute.

	 * <!-- begin-user-doc -->

	 * <!-- end-user-doc -->

	 * @param value the new value of the '<em>Type</em>' attribute.

	 * @see #getType()

	 * @generated

	 */

	void setType(String value);

	/**

	 * Returns the value of the '<em><b>Columns</b></em>' reference list.

	 * The list contents are of type {@link org.eclipse.hyades.resources.database.internal.dbmodel.Column}.

	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.resources.database.internal.dbmodel.Column#getConstraints <em>Constraints</em>}'.

	 * <!-- begin-user-doc -->

	 * <p>

	 * If the meaning of the '<em>Columns</em>' reference list isn't clear,

	 * there really should be more of a description here...

	 * </p>

	 * <!-- end-user-doc -->

	 * @return the value of the '<em>Columns</em>' reference list.

	 * @see org.eclipse.hyades.resources.database.internal.dbmodel.DbmodelPackage#getConstraint_Columns()

	 * @see org.eclipse.hyades.resources.database.internal.dbmodel.Column#getConstraints

	 * @model type="org.eclipse.hyades.resources.database.internal.dbmodel.Column" opposite="constraints"

	 * @generated

	 */

	EList getColumns();

} // Constraint

