/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ServiceRegistryTester.java,v 1.4 2005/02/16 22:20:15 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.tests.collection.correlation;

import org.eclipse.hyades.collection.correlation.BaseApplicationImpl;
import org.eclipse.hyades.collection.correlation.BaseCorrelatorDataImpl;
import org.eclipse.hyades.collection.correlation.IApplication;
import org.eclipse.hyades.collection.correlation.ICorrelatorData;
import org.eclipse.hyades.collection.correlation.ServiceRegistry;

/**
 * This is the tester for {@link ServiceRegistry}.
 * 
 * @author Qiyan Li
 */
public class ServiceRegistryTester extends BaseApplicationImpl implements IApplication {
    private int id;

    /**
     * @see org.eclipse.hyades.collection.correlation.BaseApplicationImpl#instantiateCorrelator()
     */
    public BaseCorrelatorDataImpl instantiateCorrelator() {
        return null;
    }

    /**
     * @see org.eclipse.hyades.collection.correlation.IApplication#createCorrelatorData()
     */
    public ICorrelatorData createCorrelatorData() {
        return null;
    }

    /**
     * @see org.eclipse.hyades.collection.correlation.IApplication#getId()
     */
    public int getId() {
        return id;
    }

    /**
     * @see org.eclipse.hyades.collection.correlation.IApplication#getVersion()
     */
    public int getVersion() {
        return 0;
    }

    public static void main(String[] args) {
        
        System.err.println("#1: create 3 applications...");
        ServiceRegistryTester a = new ServiceRegistryTester();
        a.id = 1;
        System.err.println("application (id = " + a.id + "): " + a);
        ServiceRegistryTester b = new ServiceRegistryTester();
        b.id = 2;
        System.err.println("application (id = " + b.id + "): " + b);
        ServiceRegistryTester c = new ServiceRegistryTester();
        c.id = 3;
        System.err.println("application (id = " + c.id + "): " + c);
        System.err.println();
        
        System.err.println("#2: register applications 1, 2, and 3 with a duplicate try...");
        ServiceRegistry r = ServiceRegistry.getRegistry();
        System.err.println("registerApplication (id = " + a.id + "): " + r.registerApplication(a));
        System.err.println("registerApplication (id = " + a.id + "): " + r.registerApplication(a));
        System.err.println("registerApplication (id = " + b.id + "): " + r.registerApplication(b));
        System.err.println("registerApplication (id = " + c.id + "): " + r.registerApplication(c));
        System.err.println();
        
        System.err.println("#3: locate application...");
        for (int i = -2; i < 6; i++) {
            System.err.println("getApplicationById (id = " + i + "): " + r.getApplicationById(i));
        }
        System.err.println();
        
        System.err.println("#4: deregister applications...");
        r = ServiceRegistry.getRegistry();
        ServiceRegistryTester d = new ServiceRegistryTester();
        d.id = 4;
        System.err.println("deregisterApplication (id = " + d.id + "): " + r.deregisterApplication(d));
        System.err.println("deregisterApplication (id = " + a.id + "): " + r.deregisterApplication(a));
        System.err.println("deregisterApplication (id = " + b.id + "): " + r.deregisterApplication(b));
        System.err.println("deregisterApplication (id = " + c.id + "): " + r.deregisterApplication(c));
        System.err.println("deregisterApplication (id = " + d.id + "): " + r.deregisterApplication(d));
        System.err.println();
        
        System.err.println("EOT");
    }
}
