/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IProfilingSetTypeGroup.java,v 1.5 2005/02/16 22:24:02 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.trace.ui.launcher;

import org.eclipse.jface.resource.ImageDescriptor;
/**
 * Profiling Set Type Group interface
 * A profiling type group
 * (ie. Memory Analysis, Time Analysis, Memory Leak Analysis, Code Coverage..)
 */
public interface IProfilingSetTypeGroup {
	
	/**
	 * @return Returns the icon.
	 */
	public ImageDescriptor getIcon();
	
	/**
	 * @param icon The icon to set.
	 */
	public void setIcon(ImageDescriptor icon);
	
	/**
	 * @return Returns the id.
	 */
	public String getId();
	
	/**
	 * @param id The id to set.
	 */
	public void setId(String id);
	
	/**
	 * @return Returns the name.
	 */
	public String getName();
	
	/**
	 * @param name The name to set.
	 */
	public void setName(String name);	
	
	/**
	 * @return Returns the description.
	 */
	public String getDescription();
	
	/**
	 * @param name The description to set.
	 */
	public void setDescription(String description);	
	
}
